/*
//================================================

Finance Toolbar
This show you the real time stock market information.
Copyright (C) 2012 Stefan vd - All Rights Reserved.
www.stefanvd.net

//================================================
*/

// main script
// FinanceToolbar namespace.
if ("undefined" == typeof(FinanceToolbar)) {
  var FinanceToolbar = {};
};

(function(ns) {
    ns.extension_id = "Finance Toolbar (Firefox) extension";
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
    ns.init = function () {

// welcome page
var firstrun = Services.prefs.getBoolPref("extensions.FinanceToolbar.firstrun");
var curVersion = "0.2.8";

if (firstrun) {
// Adding button by default ------------
  var myId    = "FinanceToolbar-button"; // ID of button to add
  var afterId = "urlbar-container";    // ID of element to insert after
  var navBar  = document.getElementById("nav-bar");
  var currentSet = navBar.getAttribute("currentset");
    if (!currentSet)
        currentSet = navBar.currentSet;

    var curSet = currentSet.split(",");
    if (curSet.indexOf(myId) == -1){
		var set = curSet.concat(myId);
		navBar.setAttribute("currentset", set.join(","));
		navBar.currentSet = set.join(",");
		document.persist(navBar.id, "currentset");
    try {
      BrowserToolboxCustomizeDone(true);
    }
    catch (e) {}
  }
//------------
  Services.prefs.setBoolPref("extensions.FinanceToolbar.firstrun", false);
  Services.prefs.setCharPref("extensions.FinanceToolbar.installedVersion", curVersion);
  /* Code related to firstrun */
  window.setTimeout(function(){ gBrowser.selectedTab = gBrowser.addTab("http://www.stefanvd.net/project/financetoolbarfirefoxguide.htm"); }, 1000);
  window.setTimeout(function(){ gBrowser.selectedTab = gBrowser.addTab("http://www.stefanvd.net/project/financetoolbarfirefox.htm"); }, 1000);
} else {
  try {
    var installedVersion = Services.prefs.getCharPref("extensions.FinanceToolbar.installedVersion");
    if (curVersion > installedVersion) {
      Services.prefs.setCharPref("extensions.FinanceToolbar.installedVersion", curVersion);
      /* Code related to upgrade */
    }
  } catch (ex) {
    /* Code related to a reinstall */
  }
}
	
	// For accessing browser window from sidebar code.
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
               .getInterface(Components.interfaces.nsIWebNavigation)
               .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
               .rootTreeItem
               .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
               .getInterface(Components.interfaces.nsIDOMWindow);
    var gBrowser = mainWindow.gBrowser;
    if (gBrowser.addEventListener) {
        gBrowser.addEventListener("load",pageLoaded,true);
    }
	
	function pageLoaded(aEvent) {
    if ((aEvent.originalTarget.nodeName == '#document') && (aEvent.originalTarget.defaultView.location.href == gBrowser.currentURI.spec)) 
    {
	var tab = documentToTab(gBrowser.contentDocument);
	
	// check www.stefanvd.net then inject detection
	var checktabfullurl = window.top.getBrowser().selectedBrowser.contentWindow.location.host;
	if(checktabfullurl == "www.stefanvd.net"){
	firefox.tabs.executeScript(tab, {file: "chrome://FinanceToolbar/content/js/content.js"});
	}
    } // end close content script
	}

        firefox.extension.onRequest.addListener(function(request, sender, sendResponse) {
            if ( request.name == "finrequest" ) {
				sendResponse({marqueebehaviour: prefManager.getCharPref("extensions.FinanceToolbar.marqueebehaviour"), direction: prefManager.getCharPref("extensions.FinanceToolbar.direction"), scrollamount: prefManager.getCharPref("extensions.FinanceToolbar.scrollamount"), japan: prefManager.getBoolPref("extensions.FinanceToolbar.japan"), xminutes: prefManager.getBoolPref("extensions.FinanceToolbar.xminutes"), favoritestock: prefManager.getBoolPref("extensions.FinanceToolbar.favoritestock"), favo1: prefManager.getCharPref("extensions.FinanceToolbar.favo1"), favo2: prefManager.getCharPref("extensions.FinanceToolbar.favo2"), favo3: prefManager.getCharPref("extensions.FinanceToolbar.favo3"), favo4: prefManager.getCharPref("extensions.FinanceToolbar.favo4"), excludedstock: prefManager.getBoolPref("extensions.FinanceToolbar.excludedstock"), getinfovaluestock: prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluestock"), getinfovaluepercent: prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluepercent"), getinfovaluemc: prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluemc")});
			}
        });
    };
	
    var documentToTab = function(doc) {
        return {
            document: doc,
            url: doc.location.href
        }
    };

// performance detect status toolbar	
window.addEventListener("beforecustomization", customizeStart, false);
window.addEventListener("aftercustomization", customizeEnd, false);
window.addEventListener("customizationchange", customizeChange, false);

function customizeStart(e) {
  /* now we know the user has started customizing */
  if (document.getElementById("FinanceToolbar").collapsed){ // hidden
		document.getElementById("financetoolbar-iframe").src = "";
	} else {
		document.getElementById("financetoolbar-iframe").src = "chrome://FinanceToolbar/content/toolbar.html";
	}
}
 
function customizeEnd(e) {
/* the user has finished customizing */
}
 
function customizeChange(e) {
/* the user has made a change to the toolbox */
}

document.getElementById("FinanceToolbar").addEventListener("DOMAttrModified", function(){
	if (document.getElementById("FinanceToolbar").collapsed){ document.getElementById("financetoolbar-iframe").src = ""; } // hidden
	else { document.getElementById("financetoolbar-iframe").src = "chrome://FinanceToolbar/content/toolbar.html"; }
}, false);
/*---*/

    var evalInSandbox = function(code, codebase, sandbox ){
        if (Components.utils && Components.utils.Sandbox) {
            // DP beta+
            Components.utils.evalInSandbox(code, sandbox);
        } else if (Components.utils && Components.utils.evalInSandbox) {
            // DP alphas
            Components.utils.evalInSandbox(code, codebase, sandbox);
        } else if (Sandbox) {
            // 1.0.x
            evalInSandbox(code, sandbox, codebase);
        } else {
            throw new Error("Could not create sandbox.");
        }
    };

    var getFileContent = function( file ) {
        var ioService=Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService);
        var scriptableStream=Components
            .classes["@mozilla.org/scriptableinputstream;1"]
            .getService(Components.interfaces.nsIScriptableInputStream);
        var unicodeConverter=Components
            .classes["@mozilla.org/intl/scriptableunicodeconverter"]
            .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        unicodeConverter.charset="UTF-8";

        var channel=ioService.newChannel( file, "UTF-8", null);
        var input=channel.open();
        scriptableStream.init(input);
        var str=scriptableStream.read(input.available());
        scriptableStream.close();
        input.close();

        try {
            return unicodeConverter.ConvertToUnicode(str);
        } catch (e) {
            return str;
        } 
    };

    var console = {};
    console._service = Components.classes["@mozilla.org/consoleservice;1"]
        .getService(Components.interfaces.nsIConsoleService);
    console.log = function(msg) {
        console._service.logStringMessage(msg);
    };

    var firefox = {};

    firefox.tabs = {};
    firefox.tabs.executeScript = function(tab, details) {
        var unsafeWin = tab.document.defaultView;
        var safeWin = new XPCNativeWrapper(unsafeWin);
        var sandbox = new Components.utils.Sandbox(safeWin);
        sandbox.window = safeWin;
        sandbox.document = sandbox.window.document;
        sandbox.unsafeWindow = unsafeWin;
        sandbox.__proto__ = sandbox.window;
        sandbox.firefox = {};
        sandbox.firefox.extension = new firefox.tabs.extension(tab.document);
        sandbox.console = console;
        var code = (typeof details.code != "undefined"
                    ? details.code
                    : ( typeof details.file != "undefined" ? getFileContent(details.file) : undefined ) );
        if ( code ) {
            try {
                evalInSandbox( code, tab.url, sandbox );
            } catch ( e ) {
                console.log("[ERROR] " + e );
            }
        }
    };

    firefox.tabs.event_id = ns.extension_id+".tabs.Request";
    firefox.tabs.request = {};
    
    firefox.tabs.sendRequest = function(tab, request, requestCallback) {
        var evt = tab.document.createEvent("Events");
        evt.initEvent(firefox.tabs.event_id, true, false);
        firefox.tabs.request = {
            data: request,
            callback: requestCallback
        };
        tab.document.dispatchEvent(evt);
    };

    firefox.tabs.extension = function(doc) {
        this.document = doc;
        this.event_id = firefox.tabs.event_id;

        var listeners = [];
        var handler = function(evt) {
            var request = firefox.tabs.request;
            for ( var i=0; i<listeners.length; i++ ) {
                listeners[i](request.data, null, request.callback);
            }
        };

        this.onRequest = {
            addListener: function(listener) {
                listeners.push(listener);
            },
            
            removeListener: function(listener) {
                for ( var i=0; i<listeners.length; i++ ) {
                    if ( listener == listeners[i] ) {
                        listeners.splice(i, 1);
                    }
                }
            }
        };
        doc.addEventListener(firefox.tabs.event_id, handler, false, true );
    };
    
    var listeners = [];
    firefox.tabs.extension.prototype.sendRequest = function(request, responseCallback) {
        if ( typeof responseCallback!="function" ) {
            responseCallback = function() {};
        }
        for ( var i=0; i<listeners.length; i++ ) {
            listeners[i](request, { tab: documentToTab(this.document) }, responseCallback);
        }
    };

    firefox.extension = {};
    firefox.extension.onRequest = {
        addListener: function(listener) {
            listeners.push(listener);
        },
        removeListener: function(listener) {
            for ( var i=0; i<listeners.length; i++ ) {
                if ( listener == listeners[i] ) {
                    listeners.splice(i, 1);
                }
            }
        }
    };
})(FinanceToolbar);

window.addEventListener("load", function() {FinanceToolbar.init();}, false);